/// @cond EO_CXX_EO_IMPL

inline ::evas::object elm::naviframe::item_pop() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_pop());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::naviframe::item_insert_before(::elm::widget_item before_, ::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::naviframe::item_push(::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_push(::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::naviframe::item_simple_promote(::evas::object content_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_simple_promote(::efl::eolian::to_c(content_)));
}

inline ::elm::widget_item elm::naviframe::item_insert_after(::elm::widget_item after_, ::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::naviframe::event_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_event_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::naviframe::event_enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_event_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline bool elm::naviframe::content_preserve_on_pop_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_content_preserve_on_pop_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::naviframe::content_preserve_on_pop_set(bool preserve_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_content_preserve_on_pop_set(::efl::eolian::to_c(preserve_)));
}

inline bool elm::naviframe::prev_btn_auto_pushed_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_prev_btn_auto_pushed_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::naviframe::prev_btn_auto_pushed_set(bool auto_pushed_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_prev_btn_auto_pushed_set(::efl::eolian::to_c(auto_pushed_)));
}

inline ::efl::eina::list< ::elm::widget_item > elm::naviframe::items_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline ::elm::widget_item elm::naviframe::top_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_top_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::naviframe::bottom_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_bottom_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::naviframe::item_pop() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_pop());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::naviframe::item_insert_before(::elm::widget_item before_, ::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::naviframe::item_push(::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_push(::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::naviframe::item_simple_promote(::evas::object content_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_simple_promote(::efl::eolian::to_c(content_)));
}

inline ::elm::widget_item eo_cxx::elm::naviframe::item_insert_after(::elm::widget_item after_, ::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::naviframe::event_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_event_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::naviframe::event_enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_event_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline bool eo_cxx::elm::naviframe::content_preserve_on_pop_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_content_preserve_on_pop_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::naviframe::content_preserve_on_pop_set(bool preserve_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_content_preserve_on_pop_set(::efl::eolian::to_c(preserve_)));
}

inline bool eo_cxx::elm::naviframe::prev_btn_auto_pushed_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_prev_btn_auto_pushed_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::naviframe::prev_btn_auto_pushed_set(bool auto_pushed_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_prev_btn_auto_pushed_set(::efl::eolian::to_c(auto_pushed_)));
}

inline ::efl::eina::list< ::elm::widget_item > eo_cxx::elm::naviframe::items_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::naviframe::top_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_top_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::naviframe::bottom_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_bottom_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::naviframe::operator ::elm::naviframe() const
{
   return *static_cast<::elm::naviframe const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::naviframe::operator ::elm::naviframe&()
{
   return *static_cast<::elm::naviframe*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::naviframe::operator ::elm::naviframe const&() const
{
   return *static_cast<::elm::naviframe const*>(static_cast<void const*>(this));
}

template <typename T>
::evas::object elm_naviframe_item_pop_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_pop();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_naviframe_item_insert_before_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * before_, const char * title_label_, Evas_Object * prev_btn_, Evas_Object * next_btn_, Evas_Object * content_, const char * item_style_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_before(::efl::eolian::to_cxx<::elm::widget_item>(before_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(title_label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(prev_btn_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(next_btn_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(content_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(item_style_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_naviframe_item_push_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * title_label_, Evas_Object * prev_btn_, Evas_Object * next_btn_, Evas_Object * content_, const char * item_style_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_push(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(title_label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(prev_btn_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(next_btn_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(content_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(item_style_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_naviframe_item_simple_promote_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * content_)
{
   try
      {
         static_cast<T*>(self->this_)->item_simple_promote(::efl::eolian::to_cxx<::evas::object>(content_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_naviframe_item_insert_after_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * after_, const char * title_label_, Evas_Object * prev_btn_, Evas_Object * next_btn_, Evas_Object * content_, const char * item_style_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_after(::efl::eolian::to_cxx<::elm::widget_item>(after_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(title_label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(prev_btn_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(next_btn_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(content_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(item_style_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_naviframe_event_enabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->event_enabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_naviframe_event_enabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->event_enabled_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_naviframe_content_preserve_on_pop_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->content_preserve_on_pop_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_naviframe_content_preserve_on_pop_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool preserve_)
{
   try
      {
         static_cast<T*>(self->this_)->content_preserve_on_pop_set(::efl::eolian::to_cxx<bool>(preserve_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_naviframe_prev_btn_auto_pushed_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->prev_btn_auto_pushed_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_naviframe_prev_btn_auto_pushed_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool auto_pushed_)
{
   try
      {
         static_cast<T*>(self->this_)->prev_btn_auto_pushed_set(::efl::eolian::to_cxx<bool>(auto_pushed_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::list< ::elm::widget_item > elm_naviframe_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_naviframe_top_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->top_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_naviframe_bottom_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->bottom_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::naviframe >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual ::evas::object item_pop()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_pop());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_insert_before(::elm::widget_item before_, ::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_push(::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_push(::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_simple_promote(::evas::object content_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_simple_promote(::efl::eolian::to_c(content_)));
      }

      virtual ::elm::widget_item item_insert_after(::elm::widget_item after_, ::efl::eina::optional< ::efl::eina::string_view > title_label_, ::evas::object prev_btn_, ::evas::object next_btn_, ::evas::object content_, ::efl::eina::optional< ::efl::eina::string_view > item_style_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(title_label_), ::efl::eolian::to_c(prev_btn_), ::efl::eolian::to_c(next_btn_), ::efl::eolian::to_c(content_), ::efl::eolian::to_c(item_style_)));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool event_enabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_event_enabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void event_enabled_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_event_enabled_set(::efl::eolian::to_c(enabled_)));
      }

      virtual bool content_preserve_on_pop_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_content_preserve_on_pop_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void content_preserve_on_pop_set(bool preserve_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_content_preserve_on_pop_set(::efl::eolian::to_c(preserve_)));
      }

      virtual bool prev_btn_auto_pushed_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_prev_btn_auto_pushed_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void prev_btn_auto_pushed_set(bool auto_pushed_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_prev_btn_auto_pushed_set(::efl::eolian::to_c(auto_pushed_)));
      }

      virtual ::efl::eina::list< ::elm::widget_item > items_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }

      virtual ::elm::widget_item top_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_top_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item bottom_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_bottom_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::naviframe >
{
   static constexpr int value = 
#if defined(NAVIFRAME_PROTECTED) && defined(NAVIFRAME_BETA)
      14
#elif defined(NAVIFRAME_PROTECTED)
      14
#elif defined(NAVIFRAME_BETA)
      14
#else
      14
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::naviframe>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_pop_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_pop);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_insert_before_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_insert_before);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_push_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_push);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_simple_promote_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_simple_promote);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_insert_after_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_insert_after);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_event_enabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_event_enabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_event_enabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_event_enabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_content_preserve_on_pop_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_content_preserve_on_pop_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_content_preserve_on_pop_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_content_preserve_on_pop_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_prev_btn_auto_pushed_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_prev_btn_auto_pushed_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_prev_btn_auto_pushed_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_prev_btn_auto_pushed_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_top_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_top_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_bottom_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_bottom_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::naviframe >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::naviframe >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::naviframe>)
{
   return (ELM_NAVIFRAME_CLASS);
}

} } }

/// @endcond

